/*
 * deviced
 *
 * Copyright (c) 2012 - 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef __FEEDBACKD_HAPTIC_PLUGIN_INTF_H__
#define __FEEDBACKD_HAPTIC_PLUGIN_INTF_H__

#include "haptic-module.h"

struct haptic_plugin_ops {
	int (*get_device_count) (int*);
	int (*open_device) (int, int*);
	int (*close_device) (int);
	int (*vibrate_monotone) (int, int, int, int, int*);
	int (*vibrate_buffer) (int, const unsigned char*, int, int, int, int*);
	int (*vibrate_effect) (int, const char*, int, int);
	int (*is_supported) (const char*);
	int (*stop_device) (int);
	int (*get_device_state) (int, int*);
	int (*create_effect) (unsigned char*, int, const haptic_module_effect_element*, int);
	int (*get_buffer_duration) (int, const unsigned char*, int*);
	int (*convert_binary) (const unsigned char*, int, const char*);
};

const struct haptic_plugin_ops *get_haptic_plugin_interface();

#endif	/* __FEEDBACKD_HAPTIC_PLUGIN_INTF_H__ */
